/*## (c) SECURITY EXPLORATIONS    2014 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import java.security.*;
import java.util.*;
import java.io.*;

public class FinalizeHelper {

 public static Object fres;

 Method m;
 Object o; 
 Object args[];
 PrintWriter out;

 public FinalizeHelper(Method m,Object o,Object args[],PrintWriter out) {
  this.m=m;
  this.o=o;
  this.args=args;
  this.out=out;
 }

 public void finalize() {
  try {
   out.println("finalize called");

   out.println(m);
   fres=m.invoke(o,args);   

   out.println("finalize exited");
  } catch(Throwable t) {t.printStackTrace(out);fres="FAIL";}

 }

 public static Object invoke_in_finalize(Method m,Object o,Object args[],PrintWriter out) {
  Object res=null;

  try {
   FinalizeHelper h=new FinalizeHelper(m,o,args,out);
   h=null;

   for(int i=0;i<10;i++) {
    System.gc();
   }

   while(fres==null) {
    Thread.currentThread().sleep(20);
   }

   res=fres;

   fres=null;
  } catch(Throwable t) {
   out.println("exception: "+t);
  }

  return res;
 }

}
